---
title: Element.slot
slug: Web/API/Element/slot
tags:
  - API
  - Element
  - Property
  - Reference
  - shadow dom
  - slot
---
<p>{{APIRef("Shadow DOM")}}</p>

<p>The <strong><code>slot</code></strong> property of the {{domxref("Element")}} interface returns the name of the shadow DOM slot the element is inserted in.</p>

<p>A slot is a placeholder inside a <a href="/en-US/docs/Web/Web_Components">web component</a> that users can fill with their own markup (see <a href="/en-US/docs/Web/Web_Components/Using_templates_and_slots">Using templates and slots</a> for more information).</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>aString</em> = <em>element</em>.slot
<em>element</em>.slot = <em>aString</em>
</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMString")}}.</p>

<h2 id="Example">Examples</h2>

<p>In our <a href="https://github.com/mdn/web-components-examples/tree/master/simple-template">simple-template example</a> (<a href="https://mdn.github.io/web-components-examples/simple-template/">see it live</a>), we create a trivial custom element example called <code>&lt;my-paragraph&gt;</code> in which a shadow root is attached and then populated using the contents of a template that contains a slot named <code>my-text</code>.</p>

<p>When <code>&lt;my-paragraph&gt;</code> is used in the document, the slot is populated by a slotable element by including it inside the element with a <code><a href="/en-US/docs/Web/HTML/Global_attributes/slot">slot</a></code> attribute with the value <code>my-text</code>. Here is one such example:</p>

<pre class="brush: html">&lt;my-paragraph&gt;
  &lt;span slot="my-text"&gt;Let's have some different text!&lt;/span&gt;
&lt;/my-paragraph&gt;</pre>

<p>In our JavaScript file we get a reference to the {{htmlelement("span")}} shown above, then log a reference to the name of the corresponding <code>&lt;slot&gt;</code> element.</p>

<pre class="brush: js">let slottedSpan = document.querySelector('my-paragraph span')
console.log(slottedSpan.slot); // logs <span class="message-body-wrapper"><span class="message-flex-body"><span class="devtools-monospace message-body"><span class="objectBox objectBox-string">'my-text'</span></span></span></span></pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('DOM WHATWG','#dom-element-slot','slot')}}</td>
   <td>{{Spec2('DOM WHATWG')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_Compatibility">Browser Compatibility</h2>

<div>

<p>{{Compat("api.Element.slot")}}</p>
</div>
